/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;


class Coord
{
public:
    int X;
    int Y;
    Coord(int, int);
};

Coord::Coord(int x, int y)
{
    this->X = x;
    this->Y = y;
}

vector<Coord> GetCoords(Coord coord, vector<vector<int> > m)
{
    vector<Coord> coords;
    if(coord.X > 0)
        coords.push_back(Coord(coord.X - 1, coord.Y));
    if(coord.Y > 0)
        coords.push_back(Coord(coord.X, coord.Y - 1));
    return coords;
}

vector<Coord> GetCoordsUp(Coord coord, vector<vector<int> > m)
{
    vector<Coord> coords;
    if(coord.X < m.size())
        coords.push_back(Coord(coord.X + 1, coord.Y));
    if(coord.Y < m.size())
        coords.push_back(Coord(coord.X, coord.Y + 1));
    return coords;
}

vector<Coord> C(vector<Coord> n, vector<Coord> m)
{
    vector<Coord> coords;
    for(int i = 0;i < m.size();i++)
        coords.push_back(m[i]);
    for(int i = 0;i < n.size();i++)
        coords.push_back(n[i]);
        return coords;
}

bool IsOn(vector<Coord> m, Coord coord)
{
    int x = coord.X;
    int y = coord.Y;
    for(int i = 0; i < m.size();i++)
        if(m[i].X == x && m[i].Y == y)
            return true;
    return false;
}

bool IsOn2(vector<Coord> m, int n, vector<vector<int> > a)
{
    for(int i = 0; i < m.size();i++)
        if(a[m[i].X][m[i].Y] == n)
            return true;
    return false;
}

vector<Coord> GetUnique(vector<Coord> n)
{
    vector<Coord> un;
    for(int i = 0;i < n.size();i++)
        if(!IsOn(un, n[i]))
            un.push_back(n[i]);
    return un;
}

vector<Coord> Delete(vector<Coord> n, vector<Coord> m, vector<vector<int> > a)
{
    vector<Coord> del;
    n = GetUnique(n);
    m = GetUnique(m);
    for(int i = n.size() - 1;i > -1;i--)
        if(IsOn2(m, a[n[i].X][n[i].Y], a))
            del.push_back(n[i]);
    return del;
}

vector<Coord> Delete2(vector<Coord> n, vector<Coord> m, vector<vector<int> > a)
{
    vector<Coord> del;
    n = GetUnique(n);
    m = GetUnique(m);
    for(int i = m.size() - 1;i > -1;i--)
        if(IsOn2(n, a[m[i].X][m[i].Y], a))
            del.push_back(m[i]);
    return del;
}


int main()
{
    int n;
    ifstream in;
    in.open("table.in");
    in >> n;
    vector<vector<int> > a;
    a.resize(n);
    for(int i = 0;i < n;i++)
    {
        a[i].resize(n);
        for(int j = 0;j < n;j++)
        {
            in >> a[i][j];
        }
    }
    in.close();
    vector<Coord> coords;
    vector<Coord> coordsUP;
    vector<Coord> newc;
    vector<Coord> newcUp;
    coords.push_back(Coord(n - 1, n - 1));
    coordsUP.push_back(Coord(0, 0));
    int l = 0;
    if(a[n - 1][n - 1] != a[0][0])
        goto o;
    for(int i = 0;i < 3;i++)
    {
        for(int j = 0;j < coords.size();j++)
            newc = C(newc, GetCoords(coords[j] , a));
        for(int j = 0;j < coordsUP.size();j++)
            newcUp = C(newcUp, GetCoordsUp(coordsUP[j], a));
        newc = Delete(newc, newcUp, a);
        newcUp = Delete2(newc, newcUp, a);
        coords = newc;
        l = coords.size();
        coordsUP = newcUp;
        newc.clear();
        newcUp.clear();
    }
    o:
    ofstream out;
    out.open("table.out");
    out << l % 101;
    out.close();
    return 0;
}

