import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class polyline {

	public static void main(String[] args) {
		try (Scanner scanner = new Scanner(new File("polyline.in"));
				BufferedOutputStream output = new BufferedOutputStream(new FileOutputStream(new File("polyline.out"))))
			{
			
				int n = scanner.nextInt();
				Point[] points = new Point[n];
				ArrayList<Point> copy = new ArrayList<>();
				
				for (int i = 0; i < n; i++) {
					int x = scanner.nextInt();
					int y = scanner.nextInt();
					
					Point p = new Point(x, y);
					
					points[i] = p;
					copy.add(p);
				}
				
				Arrays.parallelSort(points, (p1, p2) -> {
						if (p1.x < p2.x)
						{
							return -1;
						}
						
						if (p1.x == p2.x && p1.y < p2.y)
						{
							return -1;
						}
						
						if (p1.x == p2.x && p1.y > p2.y)
						{
							return 1;
						}
						
						if (p1.x > p2.x)
						{
							return 1;
						}
						
						return 0;
					});
				
				for (int i = 0; i < n - 1; i++) {
					for (int j = i; j < n - 1; j++) {
						if (points[j].x == points[j + 1].x && Math.ceil(1000 * (Point.getDist(points[i], points[j]) - Point.getDist(points[i], points[j + 1]))) < 0)
						{
							Point tmp = points[j];
							points[j] = points[j + 1];
							points[j + 1] = tmp;
						}
					}
				}
				
				for (int i = 0; i < n; i++) {
					output.write(((copy.indexOf(points[i]) + 1) + " ").getBytes());
				}
				
				output.write(("\n").getBytes());
				
			} catch (IOException e)
			{
				e.printStackTrace();
			}
	}

	static class Point {
		int x;
		int y;
		
		public Point(int x, int y)
		{
			this.x = x;
			this.y = y;
		}
		
		public static double getDist(Point p1, Point p2)
		{
			return Math.sqrt((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y));
		}
	}
}
