/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;
struct point
{
    point(int _x, int _y, int _idx)
        : x(_x), y(_y), idx(_idx)
    {}
    int x;
    int y;
    int idx;
};
vector<point> pts[20001];
bool used[2018] = {};

inline bool clockwise(const point& p1, const point& p2, const point& p3)
{
    return ((long long)(p2.y - p1.y) * (long long)(p3.x - p1.x)) >=
        ((long long)(p3.y - p1.y) * (long long)(p2.x - p1.x));
}

inline bool zero(const point& p1, const point& p2, const point& p3)
{
    return ((long long)(p2.y - p1.y) * (long long)(p3.x - p1.x)) ==
        ((long long)(p3.y - p1.y) * (long long)(p2.x - p1.x));
}

inline bool ptcomp(const point& p1, const point& p2)
{
    return p1.y < p2.y;
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    int n, x, y, xmin(300000), xmax(-300000);
    ifstream in("polyline.in");
    in >> n;
    for(int i = 1; i <= n; ++i)
    {
        in >> x >> y;
        x += 10000;
        if(x < xmin)
            xmin = x;
        if(x > xmax)
            xmax = x;
        pts[x].push_back(point(x, y, i));
    }
    in.close();
    if(xmin == xmax)
    {
        ofstream out("polyline.out");
        out << "0\n";
        out.close();
        return 0;
    }
    vector<point> ch;
    bool ang_zero = true, clock;
    for(int x = xmin; x <= xmax; ++x)
        if(!pts[x].empty())
        {
            sort(pts[x].begin(), pts[x].end(), ptcomp);
            while(ch.size() > 1 && !clockwise(ch[ch.size() - 2], ch.back(), pts[x].back()))
            {
                ch.pop_back();
                ang_zero = false;
            }
            if(ang_zero && ch.size() > 1)
                ang_zero &= zero(ch[ch.size() - 2], ch.back(), pts[x].back());
            ch.push_back(pts[x].back());
        }
    if(ch.size() == n && ang_zero)
    {
        ofstream out("polyline.out");
        out << "0\n";
        out.close();
        return 0;
    }
    for(int i = 0; i < ch.size(); ++i)
        used[ch[i].idx] = true;
    for(int i = pts[xmax].size() - 2; i >= 0; --i)
        ch.push_back(pts[xmax][i]);
    for(int x = xmax - 1; x >= xmin; --x)
        for(int i = 0; i < pts[x].size(); ++i)
            if(!used[pts[x][i].idx])
                ch.push_back(pts[x][i]);
    ofstream out("polyline.out");
    for(int i = 0; i < ch.size(); ++i)
        out << ch[i].idx << (i == ch.size() - 1 ? '\n' : ' ');
    out.close();
    return 0;
}
