/* GCC */

#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

struct Point
{
    int x, y;
    int n;
    Point(int xx = 0, int yy = 0, int nn = 0)
        :x(xx), y(yy), n(nn)
    {}

    bool operator<(Point pt)
    {
        if (this->x < pt.x)
            return true;
        if (this->x > pt.x)
            return false;
        if (this->y < pt.y)
            return true;
        return false;
    }
};

double rot(Point p, Point p1, Point p2)
{
    return (p.x - p1.x) * (p2.y - p1.y) - (p.y - p1.y) * (p2.x - p1.x);
}

double dist(Point p, Point p1)
{
    return sqrt((p.x - p1.x) * (p.x - p1.x) + (p.y - p1.y) * (p.y - p1.y));
}

Point pts[3000];

int main()
{
    freopen("polyline.in", "r", stdin);
    freopen("polyline.out", "w", stdout);
    //ios::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> pts[i - 1].x >> pts[i - 1].y;
        pts[i - 1].n = i;
    }

    sort(pts, pts + n);

    /*cout << "Sorted:\n";
    for (int i = 0; i < n; ++i)
        cout << pts[i].n << endl;*/

    for (int i = 1; i < n; ++i)
    {
        int leftmost = i;
        for (int j = i + 1; j < n; ++j)
        {
            if (rot(pts[j], pts[0], pts[leftmost]) < 0)
                leftmost = j;
            else if (rot(pts[j], pts[0], pts[leftmost]) == 0 && (i == 1 || rot(pts[j], pts[0], pts[i - 1]) == 0) && dist(pts[0], pts[leftmost]) > dist(pts[0], pts[j]))
                leftmost = j;
            else if (rot(pts[j], pts[0], pts[leftmost]) == 0 && i != 1 && rot(pts[j], pts[0], pts[i - 1]) != 0 && dist(pts[0], pts[leftmost]) < dist(pts[0], pts[j]))
                leftmost = j;
        }

        //cout << "Stage " << i << ": leftmost = " << pts[leftmost].n << endl;

        swap(pts[i], pts[leftmost]);
    }

    bool singleLine = true;
    for (int i = 2; i < n; ++i)
    {

        if (rot(pts[i], pts[0], pts[1]) != 0)
        {
            singleLine = false;
            break;
        }
    }
    if (singleLine)
    {
        cout << "0\n";
        return 0;
    }

    for (int i = 0; i < n - 1; ++i)
        cout << pts[i].n << ' ';

    cout << pts[n - 1].n;

    cout << endl;
    return 0;
}
