/* GCC */
#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>
#include <vector>
#include <map>
#include <fstream>


using namespace std;

struct TPolar
{
    double x,y;
    double polar;
    double sq;
    double num;
};

bool startchecker(TPolar mas[], int n)
{
    if (mas[0].x==mas[1].x)
    {
        int i=2;
        while (mas[i].x==mas[i-1].x && i<n) i++;
        if (i==n) return true;
    }

    if (mas[0].y==mas[1].y)
    {
        int i=2;
        while (mas[i].y==mas[i-1].y && i<n) i++;
        if (i==n) return true;
    }
    return false;
}

double getpolar(double sx, double sy, double x, double y)
{
    double polar=0;
    if (x==sx) return 90;

    polar = (y-sy)/(x-sx);
    return atan(polar)*180/3.1415;
}
double getsq(double sx, double sy, double x, double y)
{
    double i=sqrt((sx-x)*(sx-x)+(sy-y)*(sy-y));
    return i;
}

bool cmp1 (TPolar a, TPolar b)
{
    return (a.y>b.y);
}

bool cmp2 (TPolar a, TPolar b)
{
    return (a.x<b.x);
}


bool cmp3 (TPolar a, TPolar b)
{
    return (a.polar<b.polar);
}

int main()
{
    ios::sync_with_stdio(false);
    ifstream fin("polyline.in");
    ofstream fout("polyline.out");


    double minsum;
    int minco=0, n;
    TPolar mas[2030];
    fin >> n;
    bool check=true;
    for (int i=0;i<n;i++)
    {
        fin >> mas[i].x >> mas[i].y;
        mas[i].num = i+1;
        if (check) minsum=mas[i].x+mas[i].y, check = false, minco = i;
        else if (minsum>mas[i].x+mas[i].y) minsum=mas[i].x+mas[i].y, minco = i;
    }

    if (startchecker(mas, n))
    {
        fout << "0\n";
        return 0;
    }

    double startx = mas[minco].x, starty = mas[minco].y;
    mas[minco].polar=0;

    for (int i=0; i<n; i++)
    {
        mas[i].polar = getpolar(mas[minco].x, mas[minco].y, mas[i].x, mas[i].y);
        mas[i].sq = getsq(mas[minco].x, mas[minco].y, mas[i].x, mas[i].y);
        //cout << mas[i].polar << " " << " " << mas[i].sq << " " << mas[i].num << "\n";
    }


    mas[minco].polar=0;
    sort(mas, mas+n, cmp1);
    sort(mas, mas+n, cmp2);
    sort(mas, mas+n, cmp3);

    for (int i=0; i<n; i++)
    {
        fout << mas[i].num;
        if (i!=n-1) fout << " ";
    }
    fout << "\n";
    return 0;
}
