/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>
#include <iostream>
#include <cmath>

using namespace std;



struct point
{
    int x, y, ind;
    point(int a, int b, int i)
    {
        x = a;
        y = b;
        ind = i;
    }
    point()
    {
        x = 0;
        y = 0;
        ind = 0;
    }
};

bool sorter(point a, point b)
{
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool sorter2(point a, point b)
{
    return a.x < b.x || (a.x == b.x && a.y > b.y);
}

bool vecang(int x1, int y1, int x2, int y2)
{
    double mod1, mod2;
    mod1 = sqrt(x1*x1+y1*y1);
    mod2 = sqrt(x2*x2+y2*y2);
    mod1 *= mod2;
    double angle = acos(((double)(x1*x2+y1*y2))/(double)mod1);
    return angle >= 1.570796d;
}

int main()
{
    int n;
    fstream fs;
    fs.open("polyline.in", fstream::in);
    fs >> n;
    point points[n];
    bool visited[n];
    for(int i = 0; i < n; i++)
    {
        int a,b;
        fs >> a >> b;
        points[i] = point(a, b, i+1);
        visited[i] = false;
    }
    fs.close();
    sort(&points[0], &points[n], sorter);
    /*for(int i = 0; i < n; i++)
    {
        cout << points[i].x << " " << points[i].y << endl;
    }*/
    //cout << endl;
    std::vector<point> op;
    op.push_back(points[0]);
    op.push_back(points[1]);
    visited[0] = true;
    visited[1] = true;
    for(int i = 2; i < n; i++)
    {
        int x1, y1, k = op.size();
        x1 = op[k-2].x-op[k-1].x;
        y1 = op[k-2].y-op[k-1].y;
        for(int j = i; j < n; j++)
        {
            int x2, y2;
            x2 = points[j].x-op[k-1].x;
            y2 = points[j].y-op[k-1].y;
            if(vecang(x1, y1, x2, y2))
            {
                op.push_back(points[j]);
                visited[j] = true;
                i = j;
                break;
            }
            if(op[op.size()-1].x == points[n-1].x && op[op.size()-1].y == points[n-1].y)
                break;
        }
    }
    for(int i = n-1; i >= 0; i--)
    {
        if(visited[i])
            continue;
        int x1, y1, k = op.size();
        x1 = op[k-2].x-op[k-1].x;
        y1 = op[k-2].y-op[k-1].y;
        for(int j = i; j >= 0; j--)
        {
            if(visited[j])
                continue;
            int x2, y2;
            x2 = points[j].x-op[k-1].x;
            y2 = points[j].y-op[k-1].y;
            //cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
            if(vecang(x1, y1, x2, y2))
            {
                op.push_back(points[j]);
                visited[j] = true;
                i = j;
                break;
            }
            if(op[op.size()-1].x == points[n-1].x && op[op.size()-1].y == points[n-1].y)
                break;
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(!visited[i])
        {
            for(int j = 1; j < op.size(); j++)
            {
                if(points[i].x >= op[j-1].x && points[i].x <= op[j].x)
                {
                    op.insert(op.begin()+j, points[i]);
                    visited[i] = true;
                    break;
                }
            }
        }
    }

    fs.open("polyline.out", fstream::out);
    for(int i = 0; i < op.size(); i++)
        fs << op[i].ind << " ";
    fs << endl;
    fs.close();
    return 0;
}
