/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

void init_mas(vector < vector <int> > & grid, int width)
{
    for (int r = 0; r <= width + 1; r++)
    {
        grid[r].resize(width+2);
        for (int c = 0; c <= width + 1; c++)
        {
            grid[r][c] = -1;
        }
    }
}

void init_kod(int width, char kod[200])
{
    kod[0] ='1';
    for (int i = 1; i <= width -1; i++)
    {
        kod[i] = '0';
        kod[width + i - 1] = '1';
    }
}

bool inc(int width, char kod[200])
{
    if (kod[width*2-2] == 0)
    {
        kod[width*2-2] = 1;
        return true;
    }
    else
    {
        int i = width*2-2;
        while (kod[i] != '0' && i > 0)
        {
            kod[i] = '0';
            i--;
        }
        if (i > 0)
        {
            kod[i] = '1';
            return true;
        }
        else
        {
            return false;
        }
    }
}

bool palin(int width, vector <int> path)
{
    bool flag = true;
    int i = 1;
    while (flag && i <= width / 2 + 1)
    {
        if (path[i] != path[width*2 - i])
        {
            flag = false;
        }
        i++;
    }
    return flag;
}

bool check(int width, vector < vector <int> > grid, char kod[200])
{
    int x = 1, y = 1,i = 1;
    vector <int> path(200);
    do
    {
        path[i] = grid[x][y];
        if (kod[i] == '1')
        {
            y++;
        }
        else
        {
            x++;
        }
        i++;
    }
    while (y <= width && x <= width && i <= width*2 - 2);
    path[width*2 - 1] = grid[x][y];
    if (y == width && x == width && palin(width,path))
    {
        return true;
    }
    else
    {
        return false;
    }
}

int main()
{
    ifstream f1("table.in");
    ofstream f2("table.out");
    int width;
    f1 >> width;
    vector < vector <int> > grid(width+2);
    init_mas(grid,width);
    for (int r = 1; r <= width; r++)
    {
        for (int c = 1; c <= width; c++)
        {
            f1 >> grid[r][c];
        }
    }
    char kod[200];
    init_kod(width,kod);
    long int counter = 0;
    do
    {
        if (check(width,grid,kod))
        {
            counter++;
        }
    }
    while (inc(width,kod));
    f2 << counter % 101;
    f1.close();
    f2.close();
}
