/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <stack>

using namespace std;

bool check(vector <int> a);

int main()
{
    ifstream in;
    in.open("table.in", ios_base::in);
    ofstream out;
    out.open("table.out", ios_base::out);

    int m;
    in >> m;
    int n = m*m;

    vector < vector <int> > graph(n);
    vector <int> value(n);
    for (int i = 0; i < n; i++)
        in >> value[i];

    int numb;
    for (int i = 0; i < m ; i++)
        for (int j = 0; j < m; j++)
        {
            numb = i*m + j;
            if (j != m - 1)
                graph[numb].push_back(numb + 1);
            if (i != m - 1)
                graph[numb].push_back(numb + m);
        }

    vector <int> vertex_point(n, 0);
    vector <int> route(2*m - 1, 0);
    route[2*m - 2] = value[n - 1];
    stack <int> st;
    st.push(0);
    int current_vertex, end_vertex = n - 1;
    int s = 0, depth = 0;
    while (true)
    {
        current_vertex = st.top();

        if (vertex_point[current_vertex] == graph[current_vertex].size())
        {
            depth--;
            vertex_point[current_vertex] = 0;

            if (current_vertex == end_vertex && check(route))
                    s++;

            st.pop();
            if (st.empty())
                break;

            continue;
        }
        else
        {
            route[depth] = value[current_vertex];
            depth++;

            st.push(graph[current_vertex][vertex_point[current_vertex]]);
            vertex_point[current_vertex]++;
        }
    }

    out << s%101 << endl;
    in.close();
    out.close();
    return 0;
}

bool check(vector <int> a)
{
    for (int i = 0, e = a.size()/2; i < e; i++)
    {
        if (a[i] != a[a.size() - 1 - i])
            return false;
    }
    return true;
}
