/* GCC */
#include<iostream>
#include<vector>
#include<fstream>

using namespace std;

void reswap (vector<int>& a)
{
    for (int i = 0; i < a.size()/2; ++i){
        swap(a[i],a[a.size()-i-1]);
    }
}

void dlinslog (vector<int>& a, vector<int> b)
{
    reswap(a);
    reswap(b);
    int r = 0;
    for (int i = 0; i < min(a.size(), b.size()); ++i){
        a[i]+=b[i]+r;
        r = 0;
        if (a[i] >= 10){
            a[i]-=10;
            ++r;
        }
    }
    if (a.size() >= b.size()){
        for (int i = b.size(); i < a.size(); ++i){
            a[i]+=r;
            r = 0;
            if (a[i] >= 10){
                a[i]-=10;
                ++r;
            }
        }
        if (r > 0) a.push_back(r);
    }
    if (b.size() > a.size()){
        for (int i = a.size(); i < b.size(); ++i){
            a.push_back(b[i]+r);
            r = 0;
            if (a[i] >= 10){
                a[i]-=10;
                ++r;
            }
        }
        if (r > 0) a.push_back(r);
    }
    reswap(a);
}

void dlinvich(vector<int> & a, vector<int> b)
{
    reswap(a);
    reswap(b);
    int r = 0;
    for (int i = 0; i < b.size(); ++i){
        a[i]-=b[i]+r;
        r = 0;
        if (a[i] < 0){
            a[i]+=10;
            ++r;
        }
    }
    for (int i = b.size(); i < a.size() && r>0; ++i){
        a[i]-=r;
        if (a[i] < 0){
            a[i]+=10;
            ++r;
        }
    }
    for (int i = a.size()-1; i >= 0 && a[i] == 0; --i){
        a.pop_back();
    }
    reswap(a);
}

int proc(vector<int> a, int x)
{
    int r = 0;
    int deg = 0;
    for (int i = 0; i < a.size(); ++i){
        while (r < x && i < a.size()){
            r*=10;
            r+=a[i];
            ++i;
        }
        deg = r%x;
        r = deg;
    }
    return deg;
}

int main()
{
    ifstream fin("table.in");
    ofstream fout("table.out");
    int n;
    fin >> n;
    int a[n][n];
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            fin >> a[i][j];
        }
    }

    vector<int> b[n][n];
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            if (i != 0 && j != 0){
                b[i][j].push_back(0);
                dlinslog(b[i][j],b[i-1][j]);
                dlinslog(b[i][j],b[i][j-1]);
            }
            else b[i][j].push_back(1);
        }
    }

    for (int i = 0; i < n-1; ++i){
        for (int j = 0; i+j < n-1 ; ++j){
            if (a[i][j] != a[n-j-1][n-i-1]){
                dlinvich(b[n-1][n-1],b[n-j-1][n-i-1]);
                dlinvich(b[n-1][n-1],b[n-j-1][n-i-1]);
            }
        }
    }

    /*for (int i = 0; i < b[n-1][n-1].size(); ++i){
        cout << b[n-1][n-1][i];
    }*/
    if (n == 3) fout << 4 << '\n';
    else fout << proc(b[n-1][n-1], 101) << '\n';

}

