package polyline;

import java.io.*;

public class polyline {
	public static void main(String[] args) {
		File file = new File("./polyline.in");

		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);

			String line = br.readLine();
			int countOfDots = Integer.parseInt(line);

			Dot[] dots = new Dot[countOfDots];

			for (int i = 0; i < countOfDots; i++) {
				line = br.readLine();

				if (line == null) {
					break;
				}

				String[] lineData = line.split(" ");
				int x = Integer.parseInt(lineData[0]);
				int y = Integer.parseInt(lineData[1]);
				int index = i + 1;

				dots[i] = new Dot(x, y, index);
			}
			
			br.close();

			if (countOfDots == 3) {
				dots = sortX(dots);
				
				writeDots(dots);
				return;
			}

//			dots = sortX(dots);
//			dots = sortY(dots);
			dots = sortXY(dots);

			writeDots(dots);
			return;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	static Dot[] sortX(Dot[] dots) {
		for (int i = 0; i < dots.length; i++) {
			int nextI = i + 1;
			
			if (nextI >= dots.length) {
				break;
			}

			if (dots[i].x > dots[nextI].x) {
				Dot nextDot = dots[nextI];
				Dot currentDot = dots[i];

				dots[i] = nextDot;
				dots[nextI] = currentDot;

				return sortX(dots);
			}
		}

		return dots;
	}

	static Dot[] sortY(Dot[] dots) {
		for (int i = 0; i < dots.length; i++) {
			int nextI = i + 1;
			
			if (nextI >= dots.length) {
				break;
			}

			if (dots[i].y > dots[i + 1].y) {
				Dot nextDot = dots[nextI];
				Dot currentDot = dots[i];

				dots[i] = nextDot;
				dots[nextI] = currentDot;

				return sortY(dots);
			}
		}

		return dots;
	}

	static Dot[] sortXY(Dot[] dots) {
		for (int i = 0; i < dots.length; i++) {
			int nextI = i + 1;
			
			if (nextI >= dots.length) {
				break;
			}

			if (dots[i].x > dots[nextI].x && dots[i].y > dots[nextI].y) {
				Dot nextDot = dots[nextI];
				Dot currentDot = dots[i];

				dots[i] = nextDot;
				dots[nextI] = currentDot;

				return sortY(dots);
			}
		}

		return dots;
	}

	static void writeDots(Dot[] dots) {
		try {
			File file = new File("./polyline.out");
			file.createNewFile();
			FileWriter fr = new FileWriter(file);
			String output = "";
			for (int i = 0; i < dots.length; i++) {
				output += dots[i].index + " ";
			}
			fr.write(output);
			fr.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
}

class Dot {
	int x;
	int y;
	int index;

	Dot(int x, int y, int index) {
		this.x = x;
		this.y = y;
		this.index = index;
	}
}
