import java.io.*;

public class Table {

	public static void main(String[] args) {
		File file = new File("./table.in");

		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);

			String line = br.readLine();
			int n = Integer.parseInt(line);

			Dot[] dots = new Dot[n * n];

			int dotI = 0;

			for (int i = 0; i < n; i++) {
				line = br.readLine();

				if (line == null) {
					break;
				}

				String[] lineData = line.split(" ");

				for (int rowI = 0; rowI < lineData.length; rowI++) {
					int x = rowI;
					int y = i;
					int number = Integer.parseInt(lineData[rowI]);

					dots[dotI] = new Dot(x, y, number);
					dotI++;
				}
			}

			br.close();

			int count = 0;
			int wayLength = 2 * n - 1;

			// Do way
			{
				Dot[] wayDots = new Dot[wayLength];
				int wayDotI = 0;

				// Go right n times
				goRight: for (int i = 0; i < n; i++) {
					// Find dot for this coord
					for (Dot dot : dots) {
						if (dot.y == 0 && dot.x == i) {
							wayDots[wayDotI] = dot;
							wayDotI++;
							continue goRight;
						}
					}
				}

				// Go down n - 1 times
				goDown: for (int i = 1; i < n; i++) {
					// Find dot for this coord
					for (Dot dot : dots) {
						if (dot.x == (n - 1) && dot.y == i) {
							wayDots[wayDotI] = dot;
							wayDotI++;
							continue goDown;
						}
					}
				}

				// Check mirrority
				String straight = "";
				String notstraight = "";

				for (int i = 0; i < wayDots.length; i++) {
					straight += wayDots[i].number;
				}
				for (int i = wayDots.length - 1; i >= 0; i--) {
					notstraight += wayDots[i].number;
				}

				if (straight.equals(notstraight)) {
					count++;
				}
			}

			{
				// Do way
				Dot[] wayDots = new Dot[wayLength];
				int wayDotI = 0;

				// Go down n times
				goDown: for (int i = 0; i < n; i++) {
					// Find dot for this coord
					for (Dot dot : dots) {
						if (dot.x == 0 && dot.y == i) {
							wayDots[wayDotI] = dot;
							wayDotI++;
							continue goDown;
						}
					}
				}

				// Go right n - 1 times
				goRight: for (int i = 1; i < n; i++) {
					// Find dot for this coord
					for (Dot dot : dots) {
						if (dot.y == (n - 1) && dot.x == i) {
							wayDots[wayDotI] = dot;
							wayDotI++;
							continue goRight;
						}
					}
				}

				// Check mirrority
				String straight = "";
				String notstraight = "";

				for (int i = 0; i < wayDots.length; i++) {
					straight += wayDots[i].number;
				}
				for (int i = wayDots.length - 1; i >= 0; i--) {
					notstraight += wayDots[i].number;
				}

				if (straight.equals(notstraight)) {
					count++;
				}
			}
			
			write(count);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	static void write(int count) {
		try {
			File file = new File("./table.out");
			file.createNewFile();
			FileWriter fr = new FileWriter(file);
			String output = Integer.toString(count);
			fr.write(output);
			fr.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}

class Dot {
	int x;
	int y;
	int number;

	Dot(int x, int y, int number) {
		this.x = x;
		this.y = y;
		this.number = number;
	}
}