/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef unsigned long long int my_ulong;

void read_limit(my_ulong& n)
{
    ifstream input("numbers.in");
    input >> n;
    input.close();
}

bool my_pow(my_ulong num, my_ulong power, my_ulong limit, my_ulong& output)
{
    my_ulong result = num;
    for (my_ulong i = 0; i < power - 1; ++i)
    {
        result *= num;
        if (result > limit)
        {
            return false;
        }
    }

    output = result;
    return true;
}

bool contains(const vector<my_ulong>& vec, my_ulong val) {

    for (size_t i = 0; i < vec.size(); ++i)
    {
        if (vec[i] == val)
        {
            return true;
        }
    }

    return false;
}

int main()
{
    my_ulong limit = -1;
    read_limit(limit);

    my_ulong max_depth = 64;

    int counter = 1;

    vector<my_ulong> checked_staired;

    for (my_ulong num = 2; num <= limit; ++num)
    {
        //cout << "num: " << num << endl;

        if (contains(checked_staired, num)) {
            //cout << num << " is already checked" << endl;
            continue;
        }

        my_ulong depth = 0;
        my_ulong staired = num;
        while (depth < max_depth)
        {

            if (!my_pow(num, staired, limit, staired))
            {
                max_depth = min(depth, max_depth);
                //cout << num << "^" << staired << " exceeds limit" << endl;
                break;
            }

            //cout << staired << endl;
            checked_staired.push_back(staired);

            counter += 1;
            depth += 1;
        }

        if (depth < 1) {break;}
    }

    ofstream out("numbers.out");
    out << counter << endl;
    out.close();

    return 0;
}
