/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef vector<vector<int> > table_t;

struct Position {
    int x;
    int y;

    Position(int x_in, int y_in) : x(x_in), y(y_in) {}
};

int n;

ostream& operator << (ostream& out, const vector<int>& vec) {
    for (vector<int>::const_iterator it = vec.begin(); it != vec.end(); ++it) {
        out << *it << " ";
    }

    return out;
}

void dfs_recursive(const table_t& table, vector<int>& path_values, Position pos, long long& counter) {

    path_values.push_back(table[pos.y][pos.x]);

    int depth = path_values.size();
    if (depth > n) {

        if (depth == 2 * n - 1) {
            counter += 1;
            //cout << path_values << endl;
            path_values.pop_back();
            return;
        }

        if (path_values[depth - 1] != path_values[2 * n - 1 - depth]) {
            path_values.pop_back();
            /*cout << "value mismatch: "
                << path_values[depth - 1] << " at " << depth - 1
                << " vs "
                << path_values[2 * n - 1 - depth] << " at " << 2 * n - 1 - depth
                << endl;*/
            return;
        }
    }

    if (pos.x + 1 < n) {
        dfs_recursive(table, path_values, Position(pos.x + 1, pos.y), counter);
    }

    if (pos.y + 1 < n) {
        dfs_recursive(table, path_values, Position(pos.x, pos.y + 1), counter);
    }

    path_values.pop_back();
}

int main() {

    fstream input("table.in");

    input >> n;
    table_t table(n, vector<int>(n, 0));

    for (int y = 0; y < n; ++y) {
        for (int x = 0; x < n; ++x) {
            input >> table[y][x];
        }
    }

    input.close();

    ofstream out("table.out");

    if (table[0][0] != table[n - 1][n - 1]) {
        out << 0 << endl;
        out.close();
        return 0;
    }

    vector<int> path_values;
    Position pos(0, 0);
    long long num_valid_paths = 0;
    dfs_recursive(table, path_values, pos, num_valid_paths);

    out << num_valid_paths % 101 << endl;
    out.close();

    return 0;
}
