/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <fstream>

using namespace std;

typedef long double ld;

const int MAX=1e5+1;
const ld EPS=1e-9;

struct dot
{
    int x, y, pos;
};

int n;
ld mx=-1e9, mn=1e9;
dot arr[MAX];

int d(dot a, dot b)
{
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

bool cmp(dot a, dot b)
{
    if(abs(atan(0.0+(a.y-arr[0].y)/(a.x-arr[0].x+EPS))-atan(0.0+(b.y-arr[0].y)/(b.x-arr[0].x+EPS)))<EPS)
    {
        if(abs(atan(0.0+(a.y-arr[0].y)/(a.x-arr[0].x+EPS))-mx)<EPS)
            return d(a, arr[0])<d(b, arr[0]);
        else
            return d(a, arr[0])>d(b, arr[0]);
    }
    else
        return atan(0.0+(a.y-arr[0].y)/(a.x-arr[0].x+EPS))>atan(0.0+(b.y-arr[0].y)/(b.x-arr[0].x+EPS));
}
int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("polyline.in");
    ofstream cout("polyline.out");
    cin >> n;
    for(int i=0; i<n; ++i)
    {
        cin >> arr[i].x >> arr[i].y;
        arr[i].pos=i+1;
    }
    int one=0;
    for(int i=1; i<n; ++i)
        if(arr[i].x<arr[one].x||(arr[i].x==arr[one].x&&arr[i].y<arr[one].y))
            one=i;
    swap(arr[0], arr[one]);
    for(int i=1; i<n; ++i)
    {
        if(atan(0.0+(arr[i].y-arr[0].y)/(arr[i].x-arr[0].x+EPS))>mx)
            mx=atan(0.0+(arr[i].y-arr[0].y)/(arr[i].x-arr[0].x+EPS));
        if(atan(0.0+(arr[i].y-arr[0].y)/(arr[i].x-arr[0].x+EPS))<mn)
            mn=atan(0.0+(arr[i].y-arr[0].y)/(arr[i].x-arr[0].x+EPS));
    }
    sort(arr+1, arr+n, cmp);
    if(abs(mx-mn)<EPS) cout << 0 << endl;
    else
    for(int i=0; i<n; ++i)
    {
        cout << arr[i].pos;
        if(i!=n-1) cout << " ";
        else cout << endl;
    }
    return 0;
}