/* GCC */

#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

typedef pair<int, int> pt;

vector<pair<pt, int> > v;

#define Y second
#define X first

bool cmp(pair<pt, int> a1, pair<pt, int> b1) {
    pt a = a1.X;
    pt b = b1.X;

    if (a.Y < b.Y)
        return true;
    if (a.X == b.X && a.X < b.X)
        return true;
    return false;
}

pt p0;

int dist(int x1, int y1)
{
    return x1*x1+y1*y1;
}

bool cmp_pol(pt p1, pt p2)
{
    return (p1.X - p0.X)*(p2.Y-p0.Y) - (p2.X - p0.X)*(p1.Y-p0.Y) > 0 || ((p1.X - p0.X)*(p2.Y-p0.Y) - (p2.X - p0.X)*(p1.Y-p0.Y) == 0 && dist(p1.X-p0.X, p2.X - p0.X) > dist(p2.X-p0.X, p2.Y-p0.Y));
}

bool cmp_pt(pair<pt, int> p1, pair<pt, int> p2)
{
    return cmp_pol(p1.X, p2.X);
}



int main()
{
    freopen("polyline.in", "r", stdin);
    freopen("polyline.out", "w", stdout);


    int n;
    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);

        v.push_back(make_pair(make_pair(x, y), i+1));
    }




    vector<pair<pt, int> >::iterator mn = min_element(v.begin(), v.end(), cmp);
    swap(*v.begin(), *mn);
    p0 = v.front().X;
    sort(v.begin()+1, v.end(), cmp_pt);

    for (int i = 0; i < n; ++i) {
        printf("%d ", v[i].Y);
    }

    return 0;
}
