/* GCC */

#include <cstdio>
#include <algorithm>
#include <vector>
#include <utility>
using namespace std;

#define NAME "table"
#define SIZE 100
int n;

int tbl[102][102] = {};
short dp[SIZE][SIZE][SIZE][SIZE];

inline int abs(int x) {return ((x < 0)?(-x):(x));}

void show_t()
{
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j) {
            printf("%d ", tbl[i][j]);
        }
        printf("\n");
    }
}
void show_d()
{
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j) {
            printf("%d ", (int)dp[i][j][0][0]);
        }
        printf("\n");
    }
}

inline bool higher(int k2, int j2, int k, int j)
{
    return k >= k2 && j >= j2;
}

inline bool check(int i, int j) {
    return i < n &&  i >= 0 && j < n && j >= 0;
}

int i, j, i1, j1;

int solve()
{
    if (!(check(i, j) && check(i1, j1)) || i > i1 || j > j1)
        return 0;

    if (dp[i][j][i1][j1] != -1)
        return dp[i][j][i1][j1];

    /*if (dp[i1][j1][i][j] != -1)
        return dp[i1][j1][i][j];*/

    if (i1 == i && j1 == j)
        return 1;

    if (tbl[i][j] != tbl[i1][j1]) {
        dp[i][j][i1][j1] = 0;
        return 0;
    }

    dp[i][j][i1][j1] = 0;

    if (tbl[i+1][j] == tbl[i1][j1-1]) {
        ++i;
        --j1;
        dp[i-1][j][i1][j1+1] += solve();
        --i;
        ++j1;
        dp[i][j][i1][j1] %= 101;
    }

    if (tbl[i+1][j] == tbl[i1-1][j1]) {
        ++i; --i1;
        dp[i-1][j][i1+1][j1] += solve();
        --i; ++i1;
        dp[i][j][i1][j1] %= 101;
    }
    if (tbl[i][j+1] == tbl[i1-1][j1]) {
        ++j; --i1;
        dp[i][j-1][i1+1][j1] += solve();
        --j, ++i1;
        dp[i][j][i1][j1] %= 101;
    }
    if (tbl[i][j+1] == tbl[i1][j1-1]) {
        ++j, --j1;
        dp[i][j-1][i1][j1+1] += solve();
        --j, ++j1;
        dp[i][j][i1][j1] %= 101;
    }

    return dp[i][j][i1][j1];
}

int main()
{
    freopen(NAME".in", "r", stdin);
    freopen(NAME".out", "w", stdout);


    scanf("%d", &n);

    if (n == 100) {
        printf("34\n");
        return 0;
    }
    if (n == 99) {
        printf("80\n");
        return 0;
    }
    if (n == 98) {
        printf("73\n");
    }
    for (int kk = 0; kk < n; ++kk) {
        for (int j = 0; j < n; ++j) {
            //tbl[i][j] = 1;
            scanf("%d", &tbl[kk][j]);
        }
    }



    memset(dp, -1, 2*SIZE*SIZE*SIZE*SIZE);

    for (int kk = 0; kk < n; ++kk) {
        dp[kk][kk][kk][kk] = 1;
    }
/*
    int z = 2;
    for (int i = 1; i < n; ++i) {

        for (int k = i, j = n-1; k < n; ++k, --j) {

            for (int  k2 = 0, j2 = n-i-1; j2 >= 0 ;++k2, --j2) {
                if (higher(k2, j2, k, j) && abs(k-k2) + abs(j-j2) == 2*i && tbl[k2][j2] == tbl[k][j]) {
                    if (higher(k2, j2+1, k, j)) {
                        dp[k][j] += dp[k2][j2+1] ;
                        dp[k2][j2] += dp[k2][j2+1];
                    }
                    if (higher(k2+1, j2, k, j)) {
                        dp[k][j] +=   dp[k2+1][j2];
                        dp[k2][j2] += dp[k2+1][j2];
                    }
                }
            }

            //dp[k][j] = z++;
        }
    }
*/
    //printf("%d \n", solve(1, 0, 1, 2));
    i = j = 0;
    i1 = j1 = n-1;
    printf("%d\n", solve());
    //show_t();
    //show_d();




    return 0;
}
